//ASKR.cs
//Pandan - Alt fire snippet from Ephi. Thanks, i think?
//Script cleaned by Racer. You left your fucking vacuum at my house! :(


datablock AudioProfile(ASKRHitSound)
{
   filename = "Add-Ons/Weapon_Bow/arrowHit.wav";
   description = AudioClose3d;
   preload = true;
};

//muzzle flash effects
datablock ParticleData(ASKRExplosionRingParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 500;
	lifetimeVarianceMS   = 100;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 30.0;
	spinRandomMin		= 0.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0 0 0.0 0.9";
	colors[1]     = "0.0 0.0 0.9 0.0";
	sizes[0]      = 0.2;
	sizes[1]      = 0.2;

	useInvAlpha = false;
};

datablock ParticleData(ASKRFlashParticle)
{
	dragCoefficient      = 6;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0;
	constantAcceleration = 0.0;
	lifetimeMS           = 350;
	lifetimeVarianceMS   = 15;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.0 0.0 0.9 0.9";
	colors[1]     = "0.0 0.0 0.9 0.0";
	sizes[0]      = 0.2;
	sizes[1]      = 0.3;

	useInvAlpha = false;
};

datablock ParticleData(ASKRSmokeParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 525;
	lifetimeVarianceMS   = 55;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.5 0.5 0.5 0.2";
	colors[1]     = "0.5 0.5 0.5 0.0";
	sizes[0]      = 0.15;
	sizes[1]      = 0.15;

	useInvAlpha = false;
};

datablock ParticleData(ASKRTrailParticleB)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.1;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 525;
	lifetimeVarianceMS   = 55;
	textureName          = "base/data/particles/thinring";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.0 1 1 0.2";
	colors[1]     = "0.0 1 1 0.0";
	sizes[0]      = 0.3;
	sizes[1]      = 0.4;

	useInvAlpha = false;
};

datablock ParticleEmitterData(ASKRFlashEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 3.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0;
   thetaMin         = 0;
   thetaMax         = 40;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "ASKRFlashParticle";
};


datablock ParticleEmitterData(ASKRSmokeEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "ASKRSmokeParticle";
};

//trails

datablock ParticleEmitterData(ASKRTrailEmitterB)
{
   ejectionPeriodMS = 4;
   periodVarianceMS = 0;
   ejectionVelocity = 0.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "ASKRTrailParticleB";
};


datablock ParticleEmitterData(ASKRExplosionEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 5;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "ASKRExplosionRingParticle";
};


datablock ParticleEmitterData(ASKRExplosionRingEmitter)
{
	lifeTimeMS = 50;

   	ejectionPeriodMS = 1;
   	periodVarianceMS = 0;
   	ejectionVelocity = 5;
   	velocityVariance = 0.0;
   	ejectionOffset   = 0.0;
   	thetaMin         = 89;
   	thetaMax         = 90;
   	phiReferenceVel  = 0;
   	phiVariance      = 360;
   	overrideAdvance = false;
   	particles = "ASKRExplosionRingParticle";
};



datablock ExplosionData(ASKRExplosion)
{
//   explosionShape = "";
	soundProfile = bulletHitSound;

   lifeTimeMS = 150;

   particleEmitter = ASKRExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   emitter[0] = ASKRExplosionRingEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 2;
   lightStartColor = "0.3 0.6 0.7";
   lightEndColor = "0 0 1";

   damageRadius = 0;
   radiusDamage = 100;

   impulseRadius = 0;
   impulseForce = 4000;
};

//Projectiles
AddDamageType("ASKRShellDirect",   '<bitmap:add-ons/Weapon_ASKR/CI_ASKR> %1',    '%2 <bitmap:add-ons/Weapon_ASKR/CI_ASKR> %1',0.2,1);
datablock ProjectileData(ASKRProjectileA)
{
   projectileShapeName = "Add-Ons/Weapon_Gun/bullet.dts";
   directDamage        = 35;
   directDamageType    = $DamageType::ASKRShellDirect;
   radiusDamageType    = $DamageType::ASKRShellRadius;

   brickExplosionRadius = 0;
   brickExplosionImpact = false;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 0;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse       = 1000;
   verticalImpulse     = 0;
   explosion           = ASKRExplosion;
   particleEmitter     = ASKRTrailEmitterB;

   muzzleVelocity      = 180;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 3000;
   fadeDelay           = 5000;
   bounceElasticity    = 0.0;
   bounceFriction      = 1;
   isBallistic         = false;
   gravityMod = 0.001;
   explodeOnDeath = true;

   hasLight    = true;
   lightRadius = 4.0;
   lightColor  = "0.2 0.3 0.9";
};

AddDamageType("ASKRDirect",   '<bitmap:add-ons/Weapon_ASKR/CI_ASKRshot> %1',    '%2 <bitmap:add-ons/Weapon_ASKR/CI_ASKRshot> %1',0.2,1);
datablock ProjectileData(ASKRProjectileB)
{
   projectileShapeName = "Add-Ons/Weapon_Gun/bullet.dts";
   directDamage        = 20;
   directDamageType    = $DamageType::ASKRDirect;
   radiusDamageType    = $DamageType::ASKRDirect;

   brickExplosionRadius = 0;
   brickExplosionImpact = false;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 0;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse       = 1000;
   verticalImpulse     = 0;
   explosion           = ASKRExplosion;
   particleEmitter     = ASKRTrailEmitterB;

   muzzleVelocity      = 65;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 3000;
   fadeDelay           = 5000;
   bounceElasticity    = 0.4;
   bounceFriction      = 1;
   isBallistic         = false;
   gravityMod = 0.03;
   explodeOnDeath = true;

   hasLight    = true;
   lightRadius = 4.0;
   lightColor  = "0.2 0.3 0.9";
};



//Item
datablock ItemData(ASKRItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./ASKR.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "AS KR1";
	iconName = "./ASKR";
	doColorShift = false;
	colorShiftColor = "0.25 0.25 0.25 1.000";

	 // Dynamic properties defined by the scripts
	image = ASKRImage;
	canDrop = true;
};

//Image
datablock ShapeBaseImageData(ASKRImage)
{
   // Basic Item properties
   shapeFile = "./ASKR.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = ASKRItem;
   ammo = " ";
   projectile = ASKRProjectileA;
   projectileType = Projectile;
   minShotTime = 200;   //No exploit prevention here! :D

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = false;
   colorShiftColor = ASKRItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.15;
	stateTransitionOnTimeout[0]      = "Ready";
	stateSound[0]			   = weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;

	stateName[2]                     = "Fire";
	stateTransitionOnTimeout[2]      = "Checkfire";
	stateTimeoutValue[2]             = 0.2;
	stateFire[2]                     = true;
	stateAllowImageChange[2]         = false;
	stateSequence[2]                 = "Fire";
	stateScript[2]                   = "onFire";
	stateWaitForTimeout[2]		   = true;
	stateEmitter[2]			   = ASKRFlashEmitter;
	stateEmitterTime[2]		   = 0.05;
	stateEmitterNode[2]		   = "muzzleNode";
	stateSound[2]			   = gunShot1Sound;

	stateName[3] 			   = "Smoke";
	stateEmitter[3]		         = ASKRSmokeEmitter;
	stateEmitterTime[3]		   = 1.2;
	stateEmitterNode[3]		   = "muzzleNode";
	stateTimeoutValue[3]             = 0.4;
	stateTransitionOnTimeout[3]      = "CoolDown";

	stateName[4]			   = "CoolDown";
	stateEmitter[4]			   = ASKRSmokeEmitter;
	stateSequence[4]			   = "eject";
	stateEmitterNode[4]		   = "ejectPoint";
	stateEmitterTime[4]		   = 0.3;
	stateTimeoutValue[4]             = 0.4;
	stateTransitionOnTimeout[4]	   = "Reload";

	stateName[5] 			   = "Reload";
	stateSequence[5]			   = "reload";
	stateTimeoutValue[5]             = 0.2;
	stateTransitionOnTimeout[5]      = "Ready";
	
	stateName[6] 			   = "Checkfire";
	stateTimeoutValue[6]             = 0.01;
	stateTransitionOnTimeout[6]      = "Fire";
	stateTransitionOnTriggerUp[6]  = "Smoke";
};

function ASKRImage::onFire(%this,%obj,%slot)
{
	if(%obj.getImageAmmo(%slot))
	{
		%projectile = ASKRProjectileA;
		%spread = 0.0002;
		%shellcount = 1;
	
		for(%shell=0; %shell<%shellcount; %shell++)
		{
			%vector = %obj.getMuzzleVector(%slot);
			%objectVelocity = %obj.getVelocity();
			%vector1 = VectorScale(%vector,(%projectile.muzzleVelocity+getRandom(-30,30)));
			%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
			%velocity = VectorAdd(%vector1,%vector2);
			%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
			%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
			%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
			%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
			%velocity = MatrixMulVector(%mat, %velocity);

			%p = new (%this.projectileType)()
			{
				dataBlock = %projectile;
				initialVelocity = %velocity;
				initialPosition = %obj.getMuzzlePoint(%slot);
				originPoint = %obj.getMuzzlePoint(%slot);
				sourceObject = %obj;
				sourceSlot = %slot;
				client = %obj.client;
			};
			MissionCleanup.add(%p);
		}
		return %p;
	}
	else
	{
		%projectile = ASKRProjectileB;
		%spread = 0.007;
		%shellcount = getRandom(3,5);

		for(%shell=0; %shell<%shellcount; %shell++)
		{
			%vector = %obj.getMuzzleVector(%slot);
			%objectVelocity = %obj.getVelocity();
			%vector1 = VectorScale(%vector,%projectile.muzzleVelocity);
			%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
			%velocity = VectorAdd(%vector1,%vector2);
			%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
			%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
			%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
			%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
			%velocity = MatrixMulVector(%mat, %velocity);

			%p = new (%this.projectileType)()
			{
				dataBlock = %projectile;
				initialVelocity = %velocity;
				initialPosition = %obj.getMuzzlePoint(%slot);
				originPoint = %obj.getMuzzlePoint(%slot);
				sourceObject = %obj;
				sourceSlot = %slot;
				client = %obj.client;
			};	
			MissionCleanup.add(%p);
		}
		return %p;	
	}
}







package ASKR
{
	function armor::onTrigger(%this,%player,%slot,%val)
	{
		if(%slot $= 4 && %player.getMountedImage(0) $= ASKRImage.getID())
		{
			if(%val)
			{
				%player.ASKRTrigEnable = getSimTime();
			}
			else
			{
				if(vectorDist(%player.ASKRTrigEnable,getSimTime()) < 600)
				{
					%player.setImageAmmo(0,0);
					%player.setImageTrigger(0,1);
					%player.setImageTrigger(0,0);
					%player.setImageAmmo(0,1);
				}
			}
		}
		else
			Parent::onTrigger(%this,%player,%slot,%val);
	}
};
ActivatePackage(ASKR);